import { Destroyable } from '../utils/Destroyable';
/**
 * @author Bram Willem van der Kuip <vdkuipb@gmail.com>
 */
export declare abstract class GameObject implements Destroyable {
    /**
     *
     */
    id: string;
    /**
     * Creates an instance of GameObject.
     * @param {string} [id=UniqueID.generate()]
     */
    constructor(id?: string);
    /**
     *
     * @param {number} delta
     */
    update(delta: number): void;
    /**
     *
     * @returns {object}
     */
    abstract toData(): object;
    /**
     *
     */
    destroyInstance(): void;
}
