import { UniqueID } from '../utils/UniqueID';
import { Destroyable } from '../utils/Destroyable';

/**
 * @author Bram Willem van der Kuip <vdkuipb@gmail.com>
 */
export abstract class GameObject implements Destroyable {
    /**
     *
     */
    public id: string;
    /**
     * Creates an instance of GameObject.
     * @param {string} [id=UniqueID.generate()]
     */
    public constructor(id: string = UniqueID.generate()) {
        this.id = id;
    }

    /**
     *
     * @param {number} delta
     */
    public update(delta: number): void {

    }

    /**
     *
     * @returns {object}
     */
    public abstract toData(): object;

    /**
     *
     */
    public destroyInstance(): void {
        delete this.id;
    }

}
